#ifndef TREETOKEN_HH
#define TREETOKEN_HH

#include "infotoken.hh"
#include "mm.hh"

class treeToken: public mmStorage {
 public:
  treeToken() {
    skip=(int)0; 
    letter=(int)0;
    setDepth(new treeToken(0, (int)0, (int)0, (int)0));
    count=0;
  }
  
  treeToken(char letter_, mmBlock<treeToken> skip_, mmBlock<treeToken> depth_, int count_) {
    skip=skip_;
    letter=letter_;
    setDepth(depth_);
    count=count_;
  }

  void setDepth(mmBlock<treeToken> depth_) {
    depth=depth_;
  }
  
  int count;
  char letter;			// the first and the last in the chain have 0 here
  mmBlock<treeToken> depth; 	// goes one deeper
  mmBlock<treeToken> skip;  	// goes one down
  
  inline infoToken* getInfo() {
    return (infoToken*)((treeToken*)depth);
  }
  void setInfo(infoToken* i) {
    depth=(treeToken*)i;
  }
};				 
#endif // TREETOKEN_HH
